package org.rollproject.rvrp.model.problem;


import java.io.Serializable;
import java.util.ArrayList;

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;


@XmlRootElement(namespace="org.rollproject.model.problem", name = "CompanyData")
@XmlType(namespace="org.rollproject.rvrp.model.problem", name = "CompanyData", propOrder = {"ID", "companies", "distanceList", "timeList", "description" })
public class CompanyData implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private ArrayList<Company> companies = new ArrayList<Company>();	
	private ArrayList<ListElement> distanceList = null;
	private ArrayList<ListElement> timeList = null;
	private String description = "";
	private int ID = -1;
	public CompanyData() {
		
	}


	public ArrayList<ListElement> getDistanceList() {		
		return distanceList;
	}

	public void setDistanceList(ArrayList<ListElement> distanceList) {
		this.distanceList = distanceList;
	}

	public ArrayList<ListElement> getTimeList() {		
		return timeList;
	}

	public void setTimeList(ArrayList<ListElement> timeList) {
		this.timeList = timeList;
	}

	public String getDescription() {		
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	
	public int getID() {		
		return ID;
	}

	public void setID(int iD) {
		ID = iD;
	}

	@Override
	public String toString() {		
		return "" +  ID + ", " + getDescription() + ", " + getSimpleDecription();	
	}
	
	public String getSimpleDecription(){
		String str = "";
		if(ID > 0 && ID < 6){
			str += "Depot Glasgow @ 55.853, -4.309 with " + distanceList.size()/2  + " companies available within a maximum ";  
		}
		if(ID > 5 && ID < 11){
			str += "Depot Edinburgh @ 55.934, -3.214 with " + distanceList.size()/2  + " companies available within a maximum ";  
		}
		if(ID > 13 && ID < 19){
			str += "Depot Aberdeen @ 57.149, -2.089 with " + distanceList.size()/2  + " companies available within a maximum ";  
		}
		
		if(ID == 3 || ID == 8 || ID == 16){
			str += "30";
		}
		
		if(ID == 5 || ID == 10 || ID == 18){
			str += "60";
		}
		
		if(ID == 1 || ID == 6 || ID == 14){
			str += "120";
		}
		
		if(ID == 2 || ID == 7 || ID == 15){
			str += "240";
		}
		
		if(ID == 4 || ID == 9 || ID == 17){
			str += "480";
		}
		
		if((ID > 0 && ID < 11) || (ID > 13 && ID < 19)){
			str += " minute trip of the depot";
		}
		if(ID > 10 && ID < 14){
			str += "Depot Stirling @ 56.110, -3.940 with " + distanceList.size()/2  + " companies available within a maximum 480 minute trip of the depot";  
		}
		return str;
	}
	
	
	public ArrayList<Company> getCompanies() {
		return companies;
	}


	public void setCompanies(ArrayList<Company> companies) {
		this.companies = companies;
	}


	public String getFilename(){			
		String str = getDescription() + ".xml";
		return str;		
	}
	
	
}
