package org.rollproject.rvrp.model.problem;

import java.io.Serializable;
import java.util.ArrayList;
import javax.xml.bind.annotation.XmlType;


@XmlType(namespace="org.rollproject.rvrp.model.problem", name = "job", propOrder = { "ID", "equipmentType",
		"compartmentType", "company", "timeWindow",
		"palletUnloadingTime", "fixedUnloadingTime", "palletLoadingTime", "fixedLoadingTime", "pallets" })
public class Job implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public static int id = 0;
	private int ID;	
	private EquipmentType equipmentType;	
	private CompartmentType compartmentType;	
	private TimeWindow timeWindow;
	private int palletUnloadingTime;	
	private int fixedUnloadingTime = 0;
	private int palletLoadingTime = 0;
	private int fixedLoadingTime = 0;
	private Company company;		
	private ArrayList<Pallet> pallets;

	public Job() {
		id++;
		ID = id;
	}
	
	public int getID() {
		return ID;
	}

	public void setID(int id) {
		ID = id;
	}

	
	public Company getCompany() {
		if (company == null) {
			company = new Company();
		}
		return company;
	}

	public void setCompany(Company company) {
		this.company = company;
	}

	public ArrayList<Pallet> getPallets() {
		if (pallets == null) {
			pallets = new ArrayList<Pallet>();
		}
		return pallets;
	}

	public void setPallets(ArrayList<Pallet> pallets) {
		this.pallets = pallets;
	}

	public TimeWindow getTimeWindow() {
		if (timeWindow == null) {
			timeWindow = new TimeWindow();
		}
		return timeWindow;
	}

	public void setTimeWindow(TimeWindow timeWindow) {
		this.timeWindow = timeWindow;
	}

	public int getPalletUnloadingTime() {
		return palletUnloadingTime;
	}

	public void setPalletUnloadingTime(int palletUnloadingTime) {
		this.palletUnloadingTime = palletUnloadingTime;
	}

	

	public EquipmentType getEquipmentType() {		
		return equipmentType;
	}

	public void setEquipmentType(EquipmentType equipmentType) {
		this.equipmentType = equipmentType;
	}

	public CompartmentType getCompartmentType() {		
		return compartmentType;
	}

	public void setCompartmentType(CompartmentType compartmentType) {
		this.compartmentType = compartmentType;
	}
	
	@Override
	public String toString() {
		String str = "";
		str += company.toString();
		str += ", Pallets " + pallets.size() + " \t";
		if(timeWindow != null){
			str += timeWindow.toString();
		}
		return str;
	}

	public int getFixedUnloadingTime() {
		return fixedUnloadingTime;
	}

	public void setFixedUnloadingTime(int fixedUnloadingTime) {
		this.fixedUnloadingTime = fixedUnloadingTime;
	}

	public int getPalletLoadingTime() {
		return palletLoadingTime;
	}

	public void setPalletLoadingTime(int palletLoadingTime) {
		this.palletLoadingTime = palletLoadingTime;
	}

	public int getFixedLoadingTime() {
		return fixedLoadingTime;
	}

	public void setFixedLoadingTime(int fixedLoadingTime) {
		this.fixedLoadingTime = fixedLoadingTime;
	}
}
