package org.rollproject.rvrp.model.problem;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.ArrayList;

import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;


@XmlRootElement(namespace="org.rollproject.rvrp.model.problem", name = "problem")
@XmlType(namespace="org.rollproject.rvrp.model.problem", name = "problem", propOrder = { "ID", "version", "matrixId", "depot", "vehicles", "jobs","distanceList", "timeList", "servicePeriod", "maxDrivingTime", "driverBreakLength" })
public class Problem implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private int ID;
	private String version = "1.0";
	private int matrixId = -1;
	private Company depot;
	private ArrayList<Vehicle> vehicles;
	private ArrayList<Job> jobs;
	private ArrayList<ListElement> distanceList;
	private ArrayList<ListElement> timeList;	
	private TimeWindow servicePeriod;
	private int maxDrivingTime = 270;
	private int driverBreakLength = 45;
	
	public Problem() {
			
	}

	
	public int getID() {
		return ID;
	}

	public void setID(int id) {
		ID = id;
	}

	
	public int getMatrixId() {		
		return matrixId;
	}

	public void setMatrixId(int matrixId) {
		this.matrixId = matrixId;
	}

	public ArrayList<Vehicle> getVehicles() {
		if (vehicles == null) {
			vehicles = new ArrayList<Vehicle>();
		}
		return vehicles;
	}

	public void setVehicles(ArrayList<Vehicle> vehicles) {
		this.vehicles = vehicles;
	}

	public ArrayList<Job> getJobs() {
		if (jobs == null) {
			jobs = new ArrayList<Job>();
		}
		return jobs;
	}

	public void setJobs(ArrayList<Job> jobs) {
		this.jobs = jobs;
	}

	public Company getDepot() {
		return depot;
	}

	public void setDepot(Company depot) {
		this.depot = depot;
	}

	public ArrayList<ListElement> getDistanceList() {
		return distanceList;
	}

	public void setDistanceList(ArrayList<ListElement> distanceList) {
		this.distanceList = distanceList;
	}

	public ArrayList<ListElement> getTimeList() {
		return timeList;
	}

	public void setTimeList(ArrayList<ListElement> timeList) {
		this.timeList = timeList;
	}

	public TimeWindow getServicePeriod() {
		return servicePeriod;
	}

	public void setServicePeriod(TimeWindow servicePeriod) {
		this.servicePeriod = servicePeriod;
	}

	public int getMaxDrivingTime() {
		return maxDrivingTime;
	}

	public void setMaxDrivingTime(int maxDrivingTime) {
		this.maxDrivingTime = maxDrivingTime;
	}

	public int getDriverBreakLength() {
		return driverBreakLength;
	}

	public void setDriverBreakLength(int driverBreakLength) {
		this.driverBreakLength = driverBreakLength;
	}

	public String getVersion() {
		return version;
	}

	public void setVersion(String version) {
		this.version = version;
	}	
	
	@Override
	public String toString() {		
		String str = "";
		str += "Problem ID " + ID + " with " + vehicles.size() + " Vehicles and " + jobs.size() + " Jobs ";
		return str;
	}
}
