package org.rollproject.rvrp.model.problem;

import java.io.Serializable;
import java.util.ArrayList;

import javax.xml.bind.annotation.XmlType;

import org.rollproject.rvrp.model.problem.*;

@XmlType(namespace="org.rollproject.rvrp.model.problem", name = "route", propOrder = {"ID", "vehicleID", "deliveries"})
public class Route implements Serializable{

	private static final long serialVersionUID = 1L;	
	private int vehicleID;
	private ArrayList<Delivery> deliveries;	
	private int ID = -1;
	private static int id = 0;
	private transient boolean open = true;

	public Route() {
		id++;
		ID = id;
	}
	public int getID() {
		return ID;
	}
	public void setID(int iD) {
		ID = iD;
	}
	public int getVehicleID() {
		return vehicleID;
	}

	public void setVehicleID(int vehicleID) {
		this.vehicleID = vehicleID;
	}

	public ArrayList<Delivery> getDeliveries() {
		if (deliveries == null) {
			deliveries = new ArrayList<Delivery>();
		}
		return deliveries;
	}

	public void setDeliveries(ArrayList<Delivery> deliveries) {
		this.deliveries = deliveries;
	}
	
	public boolean isOpen() {		
		return open ;
	}

	public void closeRoute(){
		open = false;
	}	
	
	@Override
	public String toString() {
		String str = "";		
		str += "Route using Vehicle " + vehicleID + "\r\n";
		for(Delivery delivery : deliveries){
			str += delivery.toString() + "\r\n";
		}
		return str;
	}
}
