package org.rollproject.rvrp.model.problem;

import java.io.Serializable;
import java.util.ArrayList;

import javax.xml.bind.annotation.XmlType;


@XmlType(namespace="org.rollproject.rvrp.model.problem", name="vehicle", propOrder={"ID", "vehicleType", "engineType", "equipmentType", "fixedCostMultiplier", "runningCostMultiplier", "co2CostMultiplier", "compartments"})
public class Vehicle implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public static int id = 0;
	private int ID;
	private VehicleType vehicleType;
	private EngineType engineType;
	private EquipmentType equipmentType;
	private double fixedCostMultiplier;
	private double runningCostMultiplier;
	private double co2CostMultiplier;	
	private ArrayList<Compartment> compartments;
	
	public Vehicle() {
		id++;
		ID = id;
	}

	public int getID() {		
		return ID;
	}

	public void setID(int id) {
		ID = id;
	}

	public ArrayList<Compartment> getCompartments() {
		if (compartments == null) {
			compartments = new ArrayList<Compartment>();
		}
		return compartments;
	}

	public void setCompartments(ArrayList<Compartment> compartments) {
		this.compartments = compartments;
	}

	public EquipmentType getEquipmentType() {		
		return equipmentType;
	}

	public void setEquipmentType(EquipmentType equipmentType) {
		this.equipmentType = equipmentType;
	}

	public double getFixedCostMultiplier() {		
		return fixedCostMultiplier;
	}

	public void setFixedCostMultiplier(double fixedCostMultiplier) {
		this.fixedCostMultiplier = fixedCostMultiplier;
	}

	public double getRunningCostMultiplier() {		
		return runningCostMultiplier;
	}

	public void setRunningCostMultiplier(double runningCostMultiplier) {
		this.runningCostMultiplier = runningCostMultiplier;
	}	
	
	
	public double getCo2CostMultiplier() {		
		return co2CostMultiplier;
	}

	public void setCo2CostMultiplier(double co2CostMultiplier) {
		this.co2CostMultiplier = co2CostMultiplier;
	}
	
	
	public VehicleType getVehicleType() {
		return vehicleType;
	}

	public void setVehicleType(VehicleType vehicleType) {
		this.vehicleType = vehicleType;
	}

	public EngineType getEngineType() {		
		return engineType;
	}

	public void setEngineType(EngineType engineType) {
		this.engineType = engineType;
	}

	@Override
	public String toString() {
		String str = "" + ID + "," + vehicleType + "," + engineType + "," + equipmentType + "," + fixedCostMultiplier + "," +  runningCostMultiplier + ", " + co2CostMultiplier + "\r\n";
		for(Compartment c : compartments){
			str += c.toString();
			if(!(compartments.indexOf(c) == compartments.size() - 1)){
				str += "\r\n";
			}
		}
		return str;
	}
	
}
